The how-to guides are compact lessons that help you work with common ksqlDB functionality.

<div class="cards">
  <div class="card how-to-guide">
    <strong>Query structured data</strong>
    <p class="card-body"><small>Process and query structured data types like structs, maps, and arrays.</small></p>
    <a href="/how-to-guides/query-structured-data">Learn →</a>
  </div>

  <div class="card how-to-guide">
    <strong>Convert a changelog to a table</strong>
    <p class="card-body"><small>Create a table representing the latest values in a stream.</small></p>
    <a href="/how-to-guides/convert-changelog-to-table">Learn →</a>
  </div>

  <div class="card how-to-guide">
    <strong>Use connector management</strong>
    <p class="card-body"><small>Source and sink data from external systems.</small></p>
    <a href="/how-to-guides/use-connector-management">Learn →</a>
  </div>
</div>

<div class="cards">
  <div class="card how-to-guide">
    <strong>Use a custom timestamp column</strong>
    <p class="card-body"><small>Perform time-based operations using a timestamp in each record.</small></p>
    <a href="/how-to-guides/use-a-custom-timestamp-column">Learn →</a>
  </div>

  <div class="card how-to-guide">
    <strong>Create a user-defined function</strong>
    <p class="card-body"><small>Extend ksqlDB and invoke code that you wrote.</small></p>
    <a href="/how-to-guides/create-a-user-defined-function">Learn →</a>
  </div>

  <div class="card how-to-guide">
    <strong>Control the case of identifiers</strong>
    <p class="card-body"><small>Specify the exact capitalization of object names.</small></p>
    <a href="/how-to-guides/control-the-case-of-identifiers">Learn →</a>
  </div>
</div>

<div class="cards">
  <div class="card how-to-guide">
    <strong>Test an application</strong>
    <p class="card-body"><small>Build test suites to assert correct program behavior.</small></p>
    <a href="/how-to-guides/test-an-app">Learn →</a>
  </div>

  <div class="card how-to-guide">
    <strong>Substitute variables</strong>
    <p class="card-body"><small>Change the content of a query based on variables.</small></p>
    <a href="/how-to-guides/substitute-variables">Learn →</a>
  </div>

  <div class="card how-to-guide contribute">
    <strong>Help us write another?</strong>
    <p class="card-body"><small>We're always looking for more guides. Just send a pull request!</small></p>
    <a href="https://github.com/confluentinc/ksql">Contribute →</a>
  </div>
</div>
